]> git.cworth.org Git - notmuch-wiki/blobdiff - remoteusage/aboriginal.mdwn
Content of remoteusage-old.mdwn "moved" to remoteusage/old.mdwn
[notmuch-wiki] / remoteusage / aboriginal.mdwn
index 540381b752913109112f8140ba7cd1054a5bfcdd..a558044f1771486a2bf03897223c64fbbe5656a2 100644 (file)
@@ -7,53 +7,58 @@ other requirements and general information.
 This solution uses one pre-made ssh connection where the client is put
 into "master" mode (-M) for connection sharing. The wrapper script then
 uses the control socket created by this pre-made ssh connection for
-its own connection.
+its own connection. As long as master ssh connection is live, slave
+can use it. Disconnecting master all future attempts to connect
+from the script will fail.
 
-Write the following code to a file, for example `remote-notmuch.sh`.
-There is just one line to that normally needs configuration:
+## The script
 
-        readonly SSH_CONTROL_SOCK='~'/.ssh/master-user@host:22
+Write the following code to a file, for example `remote-notmuch.sh`.
 
-the options howto are presented after the script.
+       #!/bin/bash
 
-## The script
+       # http://notmuchmail.org/remoteusage/aboriginal/
 
-        #!/bin/bash
+       set -eu
+       # To trace execution, outcomment next line. Note that emacs input may ...
+       #exec 2>>remote-errors; echo -- >&2; set -x # ... change (no stderr).
 
-        # http://notmuchmail.org/remoteusage/aboriginal/
+       readonly SSH_CONTROL_SOCK='~'/.ssh/master-user@host:22
 
-        set -eu
+       readonly notmuch=notmuch
 
-        readonly SSH_CONTROL_SOCK='~'/.ssh/master-user@host:22
+       printf -v ARGS '%q ' "$@" # bash feature
 
-        readonly notmuch=notmuch
+       readonly SSH_CONTROL_ARGS='-oControlMaster=no -S '$SSH_CONTROL_SOCK
 
-        printf -v ARGS '%q ' "$@" # bash feature
+       if ssh -q $SSH_CONTROL_ARGS 0.1 $notmuch $ARGS
+       then exit 0
+       else ev=$?
+       fi
 
-        readonly SSH_CONTROL_ARGS='-oControlMaster=no -S '$SSH_CONTROL_SOCK
+       # continuing here in case ssh exited with nonzero value.
 
-        if ssh $SSH_CONTROL_ARGS 0.1 $notmuch $ARGS 2>>/dev/null
-        then exit 0
-        else ev=$?
-        fi
+       case $* in
+        'config get user.primary_email') echo 'nobody@nowhere.invalid'; exit 0 ;;
+        'config get user.name') echo 'nobody'; exit 0 ;;
+        'count'*'--batch'*) while read line; do echo 1; done; exit 0 ;;
+        'count'*) echo 1; exit 0 ;;
+        'search-tags'*) echo 'errors'; exit 0 ;;
+        'search'*'--output=tags'*) echo 'errors'; exit 0 ;;
+       esac
 
-        # continuing here in case ssh exited with nonzero value.
+       if ssh $SSH_CONTROL_ARGS -O check 0.1
+       then
+        echo ' Control socket is alive but something failed during data transmission.'
+        exit $ev
+       fi
 
-        case $* in
-         'config get user.primary_email') echo 'nobody@nowhere.invalid'; exit 0 ;;
-         'config get user.name') echo 'nobody'; exit 0 ;;
-         'count'*) echo 1; exit 0 ;;
-         'search-tags'*) echo 'errors'; exit 0 ;;
-         'search'*'--output=tags'*) echo 'errors'; exit 0 ;;
-        esac
+       echo " See`sed '1d;2d;s/.//;q' "$0"` for help."
 
-        if ssh $SSH_CONTROL_ARGS -O check 0.1
-        then
-         echo ' Control socket is alive but something failed during data transmission.'
-         exit $ev
-        fi
-
-        echo " See`sed '1d;2d;s/.//;q' "$0"` for help."
+Note the `0.1` in ssh command line. It is used to avoid any opportunistic
+behaviour ssh might do; for example if control socket is not alive ssh
+would attempt to do it's own ssh connection to remote ssh server. As
+address `0.1` is invalid this attempt will fail early.
 
 ## Test
 
@@ -69,10 +74,10 @@ terminal and then test the script with `./remote-notmuch.sh help`
 
 Note that the '~' is inside single quotes for a reason. In this
 case shell never expand it to `$HOME` -- ssh does it by not reading
-`$HOME` but checking the real user home directory from `/etc/passewd`.
+`$HOME` but checking the real user home directory from `/etc/passwd`.
 For security purposes this is just how it should be.
 
-## Tunkkaa
+## Tune
 
 The path `'~'/.ssh/master-user@host:22` might look too generic to be
 used as is as the control socket after initial testing (but it can
@@ -97,12 +102,3 @@ to the `./remote-notmuch.sh` wrapper script testing with
 
 See the section *Configure Emacs on the client computer* in
 [[remoteusage|remoteusage]] how to do this. The instructions are the same.
-
-## Fun
-
-Original [BSD Licence](http://en.wikipedia.org/wiki/BSD_licenses)
-is 4-clause license.
-When 3 rd. clause was removed, the new license was not original anymore.
-Similarly, the requirement for this version are the same as in
-[[remoteusage|remoteusage]] page except the 3 rd. requirement
-(password-free login) is not effective here.